PooledObject (Apache Tomcat 8.5.84 API Documentation)

Package org.apache.tomcat.dbcp.pool2

## Interface PooledObject<T>

- Type Parameters:
    `T` - the type of object in the pool
  All Superinterfaces:
    `java.lang.Comparable<PooledObject<T>>`
  All Known Implementing Classes:
    `DefaultPooledObject`, `PooledSoftReference`

      public interface PooledObject<T>
      extends java.lang.Comparable<PooledObject<T>>

  Defines the wrapper that is used to track the additional information, such as state, for the pooled objects.

  Implementations of this class are required to be thread-safe.

  Since:
    2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allocate()` | Allocates the object.
    `int` | `compareTo​(PooledObject<T> other)` | Orders instances based on idle time - i.e. the length of time since the instance was returned to the pool.
    `boolean` | `deallocate()` | Deallocates the object and sets it `IDLE` if it is currently `ALLOCATED`.
    `boolean` | `endEvictionTest​(java.util.Deque<PooledObject<T>> idleQueue)` | Called to inform the object that the eviction test has ended.
    `boolean` | `equals​(java.lang.Object obj)` |
    `long` | `getActiveTimeMillis()` | Obtains the time in milliseconds that this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
    `long` | `getBorrowedCount()` | Gets the number of times this object has been borrowed.
    `long` | `getCreateTime()` | Obtains the time (using the same basis as `System.currentTimeMillis()`) that this object was created.
    `long` | `getIdleTimeMillis()` | Obtains the time in milliseconds that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
    `long` | `getLastBorrowTime()` | Obtains the time the wrapped object was last borrowed.
    `long` | `getLastReturnTime()` | Obtains the time the wrapped object was last returned.
    `long` | `getLastUsedTime()` | Returns an estimate of the last time this object was used.
    `T` | `getObject()` | Obtains the underlying object that is wrapped by this instance of `PooledObject`.
    `PooledObjectState` | `getState()` | Returns the state of this object.
    `int` | `hashCode()` |
    `void` | `invalidate()` | Sets the state to `INVALID`
    `void` | `markAbandoned()` | Marks the pooled object as abandoned.
    `void` | `markReturning()` | Marks the object as returning to the pool.
    `void` | `printStackTrace​(java.io.PrintWriter writer)` | Prints the stack trace of the code that borrowed this pooled object and the stack trace of the last code to use this object (if available) to the supplied writer.
    `void` | `setLogAbandoned​(boolean logAbandoned)` | Is abandoned object tracking being used?
    `void` | `setRequireFullStackTrace​(boolean requireFullStackTrace)` | Configures the stack trace generation strategy based on whether or not fully detailed stack traces are required.
    `boolean` | `startEvictionTest()` | Attempts to place the pooled object in the `PooledObjectState.EVICTION` state.
    `java.lang.String` | `toString()` | Provides a String form of the wrapper for debug purposes.
    `void` | `use()` | Record the current stack trace as the last time the object was used.

- - ### Method Detail

    - #### getObject

          T getObject()

      Obtains the underlying object that is wrapped by this instance of `PooledObject`.
      Returns:
        The wrapped object

    - #### getCreateTime

          long getCreateTime()

      Obtains the time (using the same basis as `System.currentTimeMillis()`) that this object was created.
      Returns:
        The creation time for the wrapped object

    - #### getActiveTimeMillis

          long getActiveTimeMillis()

      Obtains the time in milliseconds that this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
      Returns:
        The time in milliseconds last spent in the active state

    - #### getBorrowedCount

          long getBorrowedCount()

      Gets the number of times this object has been borrowed.
      Returns:
        The number of times this object has been borrowed.
      Since:
        2.7.0

    - #### getIdleTimeMillis

          long getIdleTimeMillis()

      Obtains the time in milliseconds that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
      Returns:
        The time in milliseconds last spent in the idle state

    - #### getLastBorrowTime

          long getLastBorrowTime()

      Obtains the time the wrapped object was last borrowed.
      Returns:
        The time the object was last borrowed

    - #### getLastReturnTime

          long getLastReturnTime()

      Obtains the time the wrapped object was last returned.
      Returns:
        The time the object was last returned

    - #### getLastUsedTime

          long getLastUsedTime()

      Returns an estimate of the last time this object was used. If the class of the pooled object implements `TrackedUse`, what is returned is the maximum of `TrackedUse.getLastUsed()` and `getLastBorrowTime()`; otherwise this method gives the same value as `getLastBorrowTime()`.
      Returns:
        the last time this object was used

    - #### compareTo

          int compareTo​(PooledObject<T> other)

      Orders instances based on idle time - i.e. the length of time since the instance was returned to the pool. Used by the GKOP idle object evictor.

      Note: This class has a natural ordering that is inconsistent with equals if distinct objects have the same identity hash code.

      Specified by:
        `compareTo` in interface `java.lang.Comparable<T>`

    - #### equals

          boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          java.lang.String toString()

      Provides a String form of the wrapper for debug purposes. The format is not fixed and may change at any time.

      Overrides:
        `toString` in class `java.lang.Object`

    - #### startEvictionTest

          boolean startEvictionTest()

      Attempts to place the pooled object in the `PooledObjectState.EVICTION` state.
      Returns:
        `true` if the object was placed in the `PooledObjectState.EVICTION` state otherwise `false`

    - #### endEvictionTest

          boolean endEvictionTest​(java.util.Deque<PooledObject<T>> idleQueue)

      Called to inform the object that the eviction test has ended.
      Parameters:
        `idleQueue` - The queue of idle objects to which the object should be returned
      Returns:
        Currently not used

    - #### allocate

          boolean allocate()

      Allocates the object.
      Returns:
        `true` if the original state was `IDLE`

    - #### deallocate

          boolean deallocate()

      Deallocates the object and sets it `IDLE` if it is currently `ALLOCATED`.
      Returns:
        `true` if the state was `ALLOCATED`

    - #### invalidate

          void invalidate()

      Sets the state to `INVALID`

    - #### setLogAbandoned

          void setLogAbandoned​(boolean logAbandoned)

      Is abandoned object tracking being used? If this is true the implementation will need to record the stack trace of the last caller to borrow this object.
      Parameters:
        `logAbandoned` - The new configuration setting for abandoned object tracking

    - #### setRequireFullStackTrace

          void setRequireFullStackTrace​(boolean requireFullStackTrace)

      Configures the stack trace generation strategy based on whether or not fully detailed stack traces are required. When set to false, abandoned logs may only include caller class information rather than method names, line numbers, and other normal metadata available in a full stack trace.
      Parameters:
        `requireFullStackTrace` - the new configuration setting for abandoned object logging
      Since:
        2.7.0

    - #### use

          void use()

      Record the current stack trace as the last time the object was used.

    - #### printStackTrace

          void printStackTrace​(java.io.PrintWriter writer)

      Prints the stack trace of the code that borrowed this pooled object and the stack trace of the last code to use this object (if available) to the supplied writer.
      Parameters:
        `writer` - The destination for the debug output

    - #### getState

          PooledObjectState getState()

      Returns the state of this object.
      Returns:
        state

    - #### markAbandoned

          void markAbandoned()

      Marks the pooled object as abandoned.

    - #### markReturning

          void markReturning()

      Marks the object as returning to the pool.